import { ListPage } from "./list.po";
import { CalculatorPage } from "./calculator.po";
import { Navbar } from "./navbar.po";
import { browser } from "protractor";

/**
 * Clone calculators
 */
describe("ngHyd − clone all calculators with all possible <select> values", () => {
  let listPage: ListPage;
  let calcPage: CalculatorPage;
  let navbar: Navbar;

  beforeEach(() => {
    listPage = new ListPage();
    calcPage = new CalculatorPage();
    navbar = new Navbar();
  });

  // get calculators list (IDs) @TODO read it from config !
  const calcTypes = [ 0, 1, 2, 3, 4, 5, 6, 8, 9, 10, 11, 12, 13, 15 ];

  // for each calculator
  for (const ct of calcTypes) {
    describe(" − clone all variations of calculator type [" + ct + "]", async () => {
      it("", async () => {
        await listPage.navigateTo();
        // click calculator button (instanciate)
        await listPage.clickMenuEntryForCalcType(ct);

        // get all select IDs outside Structures
        // get select IDs inside Structures
        // @TODO set configuration to every combination of <select> options

        // modify all <input> values and store them
        await calcPage.modifyAllInputValues();
        const sourceValues = await calcPage.storeAllInputValues();

        // clone calculator
        await browser.executeScript("window.scrollTo(0, 0);");
        await calcPage.clickCloneCalcButton();
        await browser.sleep(300);

        // check existence of the cloned module
        expect(await navbar.getAllCalculatorTabs().count()).toBe(2);

        // @TODO check <select> values

        // read all <input> values and compare them to stored ones
        const cloneValues = await calcPage.storeAllInputValues();
        expect(cloneValues).toEqual(sourceValues);
      });
    });
  }

});
